import { takeUntil } from 'rxjs/operators';
import { Observable, Subject, ReplaySubject } from 'rxjs';
import { __extends, __rest, __assign } from 'tslib';
import { Input, ChangeDetectionStrategy, ChangeDetectorRef, Component, Optional, SkipSelf, ViewEncapsulation, Directive, Host, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} obj
 * @return {?}
 */
function isSubscribableOrPromise(obj) {
    return obj instanceof Observable || obj instanceof Subject || obj instanceof Promise;
}
/**
 * @param {?} input
 * @return {?}
 */
function parseKeys(input) {
    return (Array.isArray(input) ? input : input.split(/\s+/)).filter((/**
     * @param {?} key
     * @return {?}
     */
    function (key) { return key; }));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
var AbstractContextConsumer = /** @class */ (function () {
    function AbstractContextConsumer(provider, target) {
        this.provider = provider;
        this.target = target;
        this.consumed = new Map();
        this.destroy$ = new Subject();
        this._contextMap = {};
        this._consume = '';
    }
    Object.defineProperty(AbstractContextConsumer.prototype, "contextMap", {
        get: /**
         * @return {?}
         */
        function () {
            return this._contextMap;
        },
        set: /**
         * @param {?} map
         * @return {?}
         */
        function (map) {
            this._contextMap = map || {};
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AbstractContextConsumer.prototype, "consume", {
        get: /**
         * @return {?}
         */
        function () {
            return this._consume;
        },
        set: /**
         * @param {?} consume
         * @return {?}
         */
        function (consume) {
            this._consume = consume || '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AbstractContextConsumer.prototype, "component", {
        get: /**
         * @return {?}
         */
        function () {
            return this.target['_view'].component;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @protected
     * @return {?}
     */
    AbstractContextConsumer.prototype.init = /**
     * @protected
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var consumed = parseKeys(this.consume);
        this.provider.reset$
            .pipe(takeUntil(this.destroy$))
            .subscribe((/**
         * @return {?}
         */
        function () { return _this.ngOnChanges(); }));
        if (this.provider.provide.length)
            this.provider.change$
                .pipe(takeUntil(this.destroy$))
                .subscribe((/**
             * @param {?} providerKey
             * @return {?}
             */
            function (providerKey) { return _this.syncProperties(consumed, providerKey); }));
    };
    /**
     * @protected
     * @return {?}
     */
    AbstractContextConsumer.prototype.reset = /**
     * @protected
     * @return {?}
     */
    function () {
        var _this = this;
        this.consumed.forEach((/**
         * @param {?} value
         * @param {?} key
         * @return {?}
         */
        function (value, key) {
            _this.component[key] = value;
        }));
        this.consumed.clear();
    };
    /**
     * @protected
     * @param {?} consumed
     * @param {?} providerKey
     * @return {?}
     */
    AbstractContextConsumer.prototype.syncProperties = /**
     * @protected
     * @param {?} consumed
     * @param {?} providerKey
     * @return {?}
     */
    function (consumed, providerKey) {
        /** @type {?} */
        var key = this.provider.contextMap[providerKey] || providerKey;
        key = this.contextMap[key] || key;
        if (consumed.length && consumed.indexOf(key) < 0)
            return;
        if (!this.consumed.has(key))
            this.consumed.set(key, this.component[key]);
        this.component[key] = this.provider.component[providerKey];
        this.target.markForCheck();
    };
    /**
     * @return {?}
     */
    AbstractContextConsumer.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        if (this.initialized) {
            this.destroy$.next();
            this.reset();
            if (this.target && this.provider)
                this.init();
        }
    };
    /**
     * @return {?}
     */
    AbstractContextConsumer.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.destroy$.next();
    };
    /**
     * @return {?}
     */
    AbstractContextConsumer.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.initialized = true;
        this.ngOnChanges();
    };
    AbstractContextConsumer.propDecorators = {
        contextMap: [{ type: Input }],
        consume: [{ type: Input }]
    };
    return AbstractContextConsumer;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
var ContextProviderComponent = /** @class */ (function () {
    function ContextProviderComponent(source) {
        this.source = source;
        this.initialized = false;
        this.provided = new Map();
        this._contextMap = {};
        this._provide = '';
        this.change$ = new ReplaySubject(1);
        this.reset$ = new Subject();
    }
    Object.defineProperty(ContextProviderComponent.prototype, "contextMap", {
        get: /**
         * @return {?}
         */
        function () {
            return this._contextMap;
        },
        set: /**
         * @param {?} map
         * @return {?}
         */
        function (map) {
            this._contextMap = map || {};
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ContextProviderComponent.prototype, "provide", {
        get: /**
         * @return {?}
         */
        function () {
            return this._provide;
        },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._provide = value || '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ContextProviderComponent.prototype, "component", {
        get: /**
         * @return {?}
         */
        function () {
            return this.source['_view'].component;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @private
     * @return {?}
     */
    ContextProviderComponent.prototype.init = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        setTimeout((/**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var THIS = _this;
            /** @type {?} */
            var context = new Map();
            /** @type {?} */
            var provided = parseKeys(_this.provide).filter((/**
             * @param {?} key
             * @return {?}
             */
            function (key) { return key && key in _this.component; }));
            provided.forEach((/**
             * @param {?} key
             * @return {?}
             */
            function (key) {
                if (isSubscribableOrPromise(_this.component[key])) {
                    _this.change$.next(key);
                    return;
                }
                /** @type {?} */
                var propertyDescriptor = Object.getOwnPropertyDescriptor(_this.component, key) ||
                    Object.getOwnPropertyDescriptor(((/** @type {?} */ (_this.component))).__proto__, key);
                _this.provided.set(key, propertyDescriptor);
                var value = propertyDescriptor.value, writable = propertyDescriptor.writable, getter = propertyDescriptor.get, setter = propertyDescriptor.set, prop = __rest(propertyDescriptor, ["value", "writable", "get", "set"]);
                Object.defineProperty(_this.component, key, __assign({}, prop, { get: getter
                        ? (/**
                         * @return {?}
                         */
                        function () {
                            return getter.call(this);
                        })
                        : (/**
                         * @return {?}
                         */
                        function () {
                            return context.get(key);
                        }), set: setter
                        ? (/**
                         * @return {?}
                         */
                        function () {
                            setter.apply(this, arguments);
                            THIS.change$.next(key);
                        })
                        : (/**
                         * @param {?} newValue
                         * @return {?}
                         */
                        function (newValue) {
                            context.set(key, newValue);
                            THIS.change$.next(key);
                        }) }));
                _this.component[key] = value || _this.component[key];
            }));
        }), 0);
    };
    /**
     * @private
     * @return {?}
     */
    ContextProviderComponent.prototype.reset = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        this.provided.forEach((/**
         * @param {?} propertyDescriptor
         * @param {?} key
         * @return {?}
         */
        function (propertyDescriptor, key) {
            /** @type {?} */
            var value = _this.component[key];
            Object.defineProperty(_this.component, key, propertyDescriptor);
            _this.component[key] = value;
        }));
        this.provided.clear();
        this.change$.next('');
        this.reset$.next();
    };
    /**
     * @return {?}
     */
    ContextProviderComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        if (this.initialized) {
            this.reset();
            if (this.source)
                this.init();
        }
    };
    /**
     * @return {?}
     */
    ContextProviderComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.initialized = true;
        this.ngOnChanges();
    };
    ContextProviderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'context-provider',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    ContextProviderComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef, decorators: [{ type: Optional }, { type: SkipSelf }] }
    ]; };
    ContextProviderComponent.propDecorators = {
        contextMap: [{ type: Input }],
        provide: [{ type: Input }]
    };
    return ContextProviderComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
var ContextConsumerComponent = /** @class */ (function (_super) {
    __extends(ContextConsumerComponent, _super);
    function ContextConsumerComponent(providerComponent, parent) {
        return _super.call(this, providerComponent, parent) || this;
    }
    ContextConsumerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'context-consumer',
                    template: '',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    ContextConsumerComponent.ctorParameters = function () { return [
        { type: ContextProviderComponent, decorators: [{ type: Optional }, { type: SkipSelf }] },
        { type: ChangeDetectorRef, decorators: [{ type: Optional }, { type: SkipSelf }] }
    ]; };
    return ContextConsumerComponent;
}(AbstractContextConsumer));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
var ContextConsumerDirective = /** @class */ (function (_super) {
    __extends(ContextConsumerDirective, _super);
    function ContextConsumerDirective(providerComponent, host) {
        var _this = _super.call(this, providerComponent, host) || this;
        _this.consume = '';
        return _this;
    }
    ContextConsumerDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[contextConsumer]',
                },] }
    ];
    /** @nocollapse */
    ContextConsumerDirective.ctorParameters = function () { return [
        { type: ContextProviderComponent, decorators: [{ type: Optional }, { type: SkipSelf }] },
        { type: ChangeDetectorRef, decorators: [{ type: Optional }, { type: Host }] }
    ]; };
    ContextConsumerDirective.propDecorators = {
        consume: [{ type: Input, args: ['contextConsumer',] }]
    };
    return ContextConsumerDirective;
}(AbstractContextConsumer));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxContextModule = /** @class */ (function () {
    function NgxContextModule() {
    }
    NgxContextModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        ContextConsumerComponent,
                        ContextConsumerDirective,
                        ContextProviderComponent,
                    ],
                    exports: [
                        ContextConsumerComponent,
                        ContextConsumerDirective,
                        ContextProviderComponent,
                    ],
                },] }
    ];
    return NgxContextModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxContextModule, ContextConsumerComponent, ContextConsumerDirective, ContextProviderComponent, AbstractContextConsumer as ɵa };

//# sourceMappingURL=ngx-context.js.map